; Script generated by the HM NIS Edit Script Wizard.

!define QTNOTEBINDIR ".inst"

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "QtNote"
!define /file PRODUCT_VERSION "version"
!define PRODUCT_PUBLISHER "R-Soft"
!define PRODUCT_WEB_SITE "http://qtnote.googlecode.com"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\qtnote.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define INSTDIR_REG_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define INSTDIR_REG_KEY "${PRODUCT_UNINST_KEY}"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "src\win\pen64.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_CHECKBOX
!insertmacro MUI_PAGE_LICENSE "license.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\qtnote.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Russian"

; MUI end ------

!include AdvUninstLog.nsh
# Unattended uninstallation
!insertmacro UNATTENDED_UNINSTALL

!include "LogicLib.nsh"

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "${PRODUCT_NAME}-${PRODUCT_VERSION}-setup.exe"
InstallDir "$PROGRAMFILES\QtNote"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

LangString un_confirm_message ${LANG_ENGLISH} "Do you really want to remove $(^Name)?"
LangString un_confirm_message ${LANG_RUSSIAN} "   ,    $(^Name)?"
LangString un_finished_message ${LANG_ENGLISH} "Uninstallation of $(^Name) is successfully finished."
LangString un_finished_message ${LANG_RUSSIAN} "  $(^Name)   ."

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
  !insertmacro UNINSTALL.LOG_PREPARE_INSTALL
FunctionEnd

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  !insertmacro UNINSTALL.LOG_OPEN_INSTALL
  
  SetOverwrite ifnewer
  File /r "${QTNOTEBINDIR}\*"
  CreateDirectory "$SMPROGRAMS\QtNote"
  CreateShortCut "$SMPROGRAMS\QtNote\QtNote.lnk" "$INSTDIR\qtnote.exe"
  CreateShortCut "$DESKTOP\QtNote.lnk" "$INSTDIR\qtnote.exe"
  File "Changelog"
  File "license.txt"
  
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\qtnote.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\Uninstall.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\qtnote.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  
  SetOutPath $INSTDIR
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\QtNote\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\QtNote\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
  
  WriteUninstaller "$INSTDIR\Uninstall.exe"
  
  !insertmacro UNINSTALL.LOG_CLOSE_INSTALL
SectionEnd

Function .onInstSuccess
  !insertmacro UNINSTALL.LOG_UPDATE_INSTALL
FunctionEnd

Function un.onInit
  !insertmacro MUI_UNGETLANGUAGE  
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "$(un_confirm_message)" IDYES +2
  Abort
  !insertmacro UNINSTALL.LOG_BEGIN_UNINSTALL
FunctionEnd

Section Uninstall
  !insertmacro UNINSTALL.LOG_UNINSTALL "$INSTDIR"
  Delete "$INSTDIR\Uninstall.exe"
  !insertmacro UNINSTALL.LOG_END_UNINSTALL
  
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$SMPROGRAMS\QtNote\Uninstall.lnk"
  Delete "$SMPROGRAMS\QtNote\Website.lnk"
  Delete "$DESKTOP\QtNote.lnk"
  Delete "$SMPROGRAMS\QtNote\QtNote.lnk"
  RMDir "$SMPROGRAMS\QtNote"
  
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd

Function un.onUninstSuccess
  HideWindow  
  MessageBox MB_ICONINFORMATION|MB_OK "$(un_finished_message)"
FunctionEnd
